﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.DataAnnotations;

namespace Models
{
    //[Serializable]
    //public class MaintenanceAthletesAthleteGridViewModel
    //{
    //    public int ResourceId { get; set; }

    //    public string LastName { get; set; }

    //    public string FirstName { get; set; }

    //    public string CountryId { get; set; }

    //    public string CountryName { get; set; }

    //    public string GenderId { get; set; }

    //    public string GenderName { get; set; }

    //    public string BirthDate { get; set; }

    //    public DateTime? DateOfBirth { get; set; }

    //    public bool TBD { get; set; }

    //    public bool IsNew { get; set; }

    //    public bool BenchmarksEntered { get; set; }

    //    public bool Pooled { get; set; }

    //    public string Category { get; set; }

    //    public string ResourceSpecialtyId { get; set; }

    //    public string ResourceSpecialtyName { get; set; }

    //    public int? PersonalCoachId { get; set; }

    //    public string PersonalCoachName { get; set; }

    //    public string CoachFirstName { get; set; }

    //    public string CoachLastName { get; set; }

    //    public string AssignSportId { get; set; }
    //}
    
    //[Serializable]
    //public class MaintenanceAthletesSportsInfoViewModel
    //{
    //    public int ResourceId { get; set; }

    //    public int ResourceSportId { get; set; }

    //    public string SportsId { get; set; }

    //    public string SportName { get; set; }

    //    public string DisciplineId { get; set; }

    //    public string DisciplineName { get; set; }

    //    public string EventId { get; set; }

    //    public string EventName { get; set; }

    //    public string YearId { get; set; }

    //    public string ResourceClassId { get; set; }

    //    public string ResourceClassName { get; set; }

    //    public int? EventCoachId { get; set; }

    //    public string EventCoachName { get; set; }

    //    public string SportTrackingRef { get; set; }

    //    public bool Benchmark { get; set; }

    //    public bool HasComments { get; set; }

    //    public string CoachLastName { get; set; }

    //    public string CoachFirstName { get; set; }
    //}

    //[Serializable]
    //public class MaintenanceAthletesBenchmarkSportsViewModel
    //{
    //    public int BenchmarkResourceId { get; set; }

    //    public string ResourceId { get; set; }

    //    public int ResourceSportId { get; set; }

    //    public int BenchmarkTypeId { get; set; }

    //    //[UIHint("AthletesSportsInfoBenchmarkTypeTemplate")]
    //    public string BenchmarkTypeName { get; set; }

    //    public int BenchmarkTierId { get; set; }

    //    //[UIHint("AthletesSportsInfoBenchmarkTierTemplate")]
    //    public string BenchmarkTierName { get; set; }

    //    public string YearId { get; set; }

    //    public int? OTPValue { get; set; }

    //    public int? NSOValue { get; set; }

    //    public bool HasComments { get; set; }

    //    public bool Active { get; set; }
    //}

    //[Serializable]
    //public class MaintenanceAthletesGeneralInfoViewModel
    //{
    //    public int ResourceId { get; set; }

    //    public string FirstName { get; set; }

    //    public string LastName { get; set; }

    //    public string CountryId { get; set; }

    //    public string Gender { get; set; }

    //    private DateTime? _dateOfBirth;

    //    public DateTime? DateOfBirth
    //    {
    //        get
    //        {
    //            if (_dateOfBirth == null)
    //            {
    //                return _dateOfBirth;
    //            }
    //            else
    //            {
    //                var dob = (DateTime)_dateOfBirth;
    //                return DateTime.SpecifyKind(new DateTime(dob.Year, dob.Month, dob.Day), DateTimeKind.Utc);
    //            }
    //        }
    //        set
    //        {
    //            _dateOfBirth = value;
    //            if (value != null)
    //            {
    //                var dob = (DateTime)value;
    //                _dateOfBirth = DateTime.SpecifyKind(new DateTime(dob.Year, dob.Month, dob.Day), DateTimeKind.Utc);
    //            }
    //        }
    //    }

    //    public string DateOfBirthLiteral
    //    {
    //        get
    //        {
    //            return _dateOfBirth == null ? "" : ((DateTime)DateOfBirth).ToShortDateString();
    //        }
    //    }

    //    public string PrimaryCSCId { get; set; }

    //    public string SecondaryCSCId { get; set; }

    //    public bool TBD { get; set; }

    //    public bool Pooled { get; set; }

    //    public bool IsNew { get; set; }

    //    public bool Active { get; set; }

    //    public string Comments { get; set; }

    //    public int? PersonalCoachId { get; set; }

    //    public List<ListItem> Countries { get; set; }

    //    public List<ListItem> Genders { get; set; }

    //    public List<ListItem> CSCs { get; set; }

    //    public List<ListItem> CoachResources { get; set; }

    //}

    [Serializable]
    public class MaintenanceSportsGridSportViewModel
    {
        public string SportId { get; set; }

        public string Name { get; set; }

        public string SportCode { get; set; }

        public string Gender { get; set; }

        public bool Benchmark { get; set; }

        public bool MedalEvent { get; set; }

        public string HPAID { get; set; }

        public string HPAName { get; set; }

        public string NSOID { get; set; }

        public string NSOName { get; set; }

        public string SportRankingCategoryID { get; set; }

        public string Ranking { get; set; }

        public bool HasComments { get; set; }

        public bool Editable { get; set; }
    }

    [Serializable]
    public class MaintenanceSportsGridDisciplineViewModel
    {
        public string DisciplineId { get; set; }

        public string SportCode { get; set; }

        public string Name_EN { get; set; }

        public string Name_FR { get; set; }

        public bool HasComments { get; set; }

        public bool Benchmark { get; set; }

        [UIHint("SportGenderPlusNoneTemplate")]
        public string Gender { get; set; }

        public bool MedalEvent { get; set; }
    }

    [Serializable]
    public class MaintenanceSportsGridEventViewModel
    {
        public string EventId { get; set; }

        public string SportCode { get; set; }

        public string Name_EN { get; set; }

        public string Name_FR { get; set; }

        public bool HasComments { get; set; }

        public bool Benchmark { get; set; }

        public bool TeamSport { get; set; }

        public int? TeamSize { get; set; }

        public bool ResourceTracking { get; set; }

        public bool MedalEvent { get; set; }
    }
}
